Leetcode-322. 零钱兑换

给定不同面额的硬币 coins 和一个总金额 amount。编写一个函数来计算可以凑成总金额所需的最少的硬币个数。如果没有任何一种硬币组合能组成总金额,返回 -1。

示例 1:

输入: coins = [1, 2, 5], amount = 11
输出: 3 
解释: 11 = 5 + 5 + 1

示例 2:

输入: coins = [2], amount = 3
输出: -1
说明:
你可以认为每种硬币的数量是无限的。

解法:使用dp,定义状态dp[i]为位置i时的最少方法,则dp方程如下图所示,时间复杂度,因为需要遍历amount大小的数组和coins数组,所以是O(XN),X是amount大小,N是coins大小。空间复杂度O(X)

  • Java
class Solution {
   
    public int coinChange(int[] coins, int amount) {
   
        if (coins==null || coins.length==0) return -1;
        if (amount==0) return 0;
        int[] dp = new int[amount+1];
        for (int i=1;i<=amount;i++) {
   
            dp[i] = Integer.MAX_VALUE;
        }
        for (int i=0;i<=amount;i++) {
   
            for (int coin:coins) {
   
                if (i-coin>=0) {
   
                    int tmp = dp[i-coin];
                    if (tmp!=Integer.MAX_VALUE) {
   
                        dp[i] = Math.min(tmp+1, dp[i]);
                    }
                }
            }
        }
        return dp[amount]!=Integer.MAX_VALUE?dp[amount]:-1;
    }
}
  • Python
class Solution:
    def coinChange(self, coins: List[int], amount: int) -> int:
        if not coins:return -1
        if amount==0: return 0
        maxint = 2**31-1
        dp = [maxint for _ in range(amount+1)]
        dp[0] = 0
        for i in range(1,amount+1):
            for coin in coins:
                if i-coin>=0:
                    tmp = dp[i-coin]
                    if tmp!=maxint:
                        dp[i] = min(dp[i], tmp+1)
        return dp[amount] if dp[amount]!=maxint else -1